from cpl_core.environment.application_environment_abc import \
    ApplicationEnvironmentABC
from cpl_core.logging import LoggerABC
from cpl_query.extension import List

from modules_core.abc.module_abc import ModuleABC
from modules_core.abc.module_service_abc import ModuleServiceABC


class ModuleService(ModuleServiceABC):

    def __init__(self, logger: LoggerABC, env: ApplicationEnvironmentABC):
        self._logger = logger
        self._env = env
        self._modules: List[ModuleABC] = List()

    def register(self, module: ModuleABC):
        self._modules.append(module)

    def start_modules(self):
        self._modules.for_each(lambda m: m.echo())
